#include "DxLib.h"
#include <math.h>

#define MODELNUM	(500)			// ͂鏬f̐
#define INIDIST		(50)			// S̍Œ዗
#define DIST		(500)			// S̒ǉ

#define CAMERAPOS_VS_CONST_INDEX	(9)		// J̍Wi[钸_VF[_[̒萔ԍ

// ͂鏬f̍\
struct MODEL
{
	int ModelHandle ;
	MATRIX local ;
	float rotX, rotY, rotDef ;
} ;
MODEL models[ MODELNUM ] ;		// ͂鏬f̏

int CenterSphere ;	// Sɕ\鋅̃f
int MiniSphere ;	// ͂鏬̃f
int MiniCube ;		// ͂鏬f

int cubeTex ;			// t@CǂݍރL[u}bveNX`
int dynamicCubeTex ;	// ͂鏬ff肱܂邽߂̕`ΏۂɂłL[u}bveNX`

int cubeMapVS ;		// L[u}bv`p̒_VF[_[
int cubeMapPS ;		// L[u}bv`p̃sNZVF[_[

VECTOR lookAt[ 6 ] ;	// f肱ގ͂̊`悷ۂ̃J̒_
VECTOR up[ 6 ] ;		// ڂ肱ގ͂̊`悷ۂ̃J̏

// ͂鏬f̏
void InitModel( void )
{
	int i ;

	for( i = 0 ; i < MODELNUM ; i ++ )
	{
		if( GetRand( 100 ) >= 50 )
		{
			models[ i ].ModelHandle = MV1DuplicateModel( MiniSphere ) ;
		}
		else
		{
			models[ i ].ModelHandle = MV1DuplicateModel( MiniCube ) ;
		}

		models[ i ].rotX = 0.0f ;
		models[ i ].rotY = 0.0f ;
		models[ i ].rotDef = 0.0001f + 0.01f * GetRand( 100000 ) / 100000.0f ;
		models[ i ].local = MGetTranslate( VGet( 
			( float )( ( GetRand( 1 ) * 2 - 1 ) * ( INIDIST + GetRand( DIST ) ) ),
			( float )( ( GetRand( 1 ) * 2 - 1 ) * ( INIDIST + GetRand( DIST ) ) ),
			( float )( ( GetRand( 1 ) * 2 - 1 ) * ( INIDIST + GetRand( DIST ) ) ) ) ) ;
	}
}

// ͂鏬f̍XV
void UpdateModel( void )
{
	int i ;
	MATRIX world ;

	for( i = 0 ; i < MODELNUM ; i ++ )
	{
		models[ i ].rotX += models[ i ].rotDef ;
		models[ i ].rotY += models[ i ].rotDef * 0.52764f ;
		world = MMult( models[ i ].local, MMult( MGetRotX( models[ i ].rotX ), MGetRotY( models[ i ].rotY ) ) ) ;
		MV1SetMatrix( models[ i ].ModelHandle, world ) ;
	}
}

// ͂鏬f̕`
void DrawModel( void )
{
	int i ;

	for( i = 0 ; i < MODELNUM ; i ++ )
	{
		MV1DrawModel( models[ i ].ModelHandle ) ;
	}
}

// WinMain֐
int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow )
{
	int i ;

	ChangeWindowMode( TRUE );

	if( DxLib_Init() == -1 )
	{
		 return -1 ;
	}

	// f̓ǂݍ
	CenterSphere = MV1LoadModel( "CubeMapTest_Sphere.mqo" ) ;
	MiniSphere   = MV1LoadModel( "CubeMapTest_MiniSphere.mqo" ) ;
	MiniCube     = MV1LoadModel( "CubeMapTest_MiniCube.mqo" ) ;

	// L[u}bveNX`̓ǂݍ
	cubeTex = LoadGraph( "TestCube.dds" ) ;

	// _VF[_[ƃsNZVF[_[̓ǂݍ
	cubeMapVS = LoadVertexShader( "CubeMapTestShader_VS.vso" ) ;
	cubeMapPS = LoadPixelShader( "CubeMapTestShader_PS.pso" ) ;

	// `ΏۂɂłL[u}bveNX`쐬
	SetCubeMapTextureCreateFlag( TRUE ) ;
	dynamicCubeTex = MakeScreen( 512, 512, TRUE ) ;
	SetCubeMapTextureCreateFlag( FALSE ) ;

	// f肱ފ`悷ۂɎgpJ̒_ƃJ̏ݒ
	lookAt[ 0 ] = VGet(  1.0f,  0.0f,  0.0f ) ;
	lookAt[ 1 ] = VGet( -1.0f,  0.0f,  0.0f ) ;
	lookAt[ 2 ] = VGet(  0.0f,  1.0f,  0.0f ) ;
	lookAt[ 3 ] = VGet(  0.0f, -1.0f,  0.0f ) ;
	lookAt[ 4 ] = VGet(  0.0f,  0.0f,  1.0f ) ;
	lookAt[ 5 ] = VGet(  0.0f,  0.0f, -1.0f ) ;
	up[ 0 ] = VGet(  0.0f,  1.0f,  0.0f ) ;
	up[ 1 ] = VGet(  0.0f,  1.0f,  0.0f ) ;
	up[ 2 ] = VGet(  0.0f,  0.0f, -1.0f ) ;
	up[ 3 ] = VGet(  0.0f,  0.0f,  1.0f ) ;
	up[ 4 ] = VGet(  0.0f,  1.0f,  0.0f ) ;
	up[ 5 ] = VGet(  0.0f,  1.0f,  0.0f ) ;

	// ͂鏬f̏
	InitModel() ;

	// C[v
	while( ProcessMessage() == 0 )
	{
		// ͂鏬f̍XV
		UpdateModel() ;

		// f肱ފ`悷ʂ̐JԂ
		for( i = 0 ; i < 6 ; i ++ )
		{
			// `ԍOԂ̕`Ώۂ`ΏۂɂłL[u}bviԖڂ̖ʂɐݒ
			SetRenderTargetToShader( 0, dynamicCubeTex, i ) ;

			// NA
			ClearDrawScreen() ;

			// J̉p90xɐݒ
			SetupCamera_Perspective( 90.0f / 180.0f * DX_PI_F ) ;

			// NearNbvʂFarNbvʂ̋ݒ
			SetCameraNearFar( 1.0f, 10000.0f ) ;

			// J̈ʒuƒ_AJ̏ݒ
			SetCameraPositionAndTargetAndUpVec( VGet( 0.0f, 0.0f, 0.0f ), lookAt[ i ], up[ i ] ) ;

			// ͂鏬f`
			DrawModel() ;
		}

		// `𗠉ʂɐݒ
		SetDrawScreen( DX_SCREEN_BACK ) ;

		// ʂNA
		ClearDrawScreen() ;

		// J͒S̋̂̎ړ
		static float a = 0.0f ;
		a -= 0.004f ;
		VECTOR CameraPos ;
		CameraPos = VGet( 500.0f * ( float )sin( a ), 0.0f, -500.0f * ( float )cos( a ) ) ;

		SetupCamera_Perspective( 30.0f / 180.0f * DX_PI_F ) ;
		SetCameraNearFar( 1.0f, 10000.0f ) ;
		SetCameraPositionAndTarget_UpVecY( CameraPos, VGet( 0.0f, 0.0f, 0.0f ) ) ;

		// ͂鏬f`
		DrawModel() ;


		// VF[_[`ŎgpeNX`Zbg
		SetUseTextureToShader( 2, cubeTex ) ;
		SetUseTextureToShader( 1, dynamicCubeTex ) ;

		// J̈ʒu𒸓_VF[_[̒萔ɃZbg
		SetVSConstF( CAMERAPOS_VS_CONST_INDEX, F4Get( CameraPos.x, CameraPos.y, CameraPos.z, 0.0f ) ) ;

		// VF[_[`ŎgpVF[_[Zbg
		SetUseVertexShader( cubeMapVS ) ;
		SetUsePixelShader( cubeMapPS ) ;

		// f`ɎÕVF[_[gpݒĒS̋̂`
		MV1SetUseOrigShader( TRUE ) ;
		MV1DrawModel( CenterSphere ) ;
		MV1SetUseOrigShader( FALSE ) ;

		// ݒ肵萔Zbg
		ResetVSConstF( CAMERAPOS_VS_CONST_INDEX, 1 ) ;

		// ݒ肵eNX`Zbg
		SetUseTextureToShader( 2, -1 ) ;
		SetUseTextureToShader( 1, -1 ) ;


		// ʂ̓e\ʂɔf
		ScreenFlip() ;
	}

	DxLib_End() ;		// cwCugp̏I

	return 0 ;		// \tg̏I
}
